<?

 /*************************************************************************************
 * Filename: login.php
 *
 * This file is part of the Login JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Login JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/login/
 *************************************************************************************/


 require_once($_path["include"]."cms.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."history.php");

 class Plugin_login extends Base_Plugin
 {
  function main()
  {
   global $_config;

   if(!$this->config)
    return false;

   if((request("e")=="login"||request("e")=="logout")&&request("s")) //login/logout attempt
   {
    $d=Data::cache($_config->get("usermodule"), "user");

    if(!$d->submit())
    {
     $this->e->add($d->e);
     return true;
    }
   }

   return true;
  }

  function cache(&$cacheTime, &$cacheKey)
  {
   global $_config;

   if(request("s")) //submit
    return false; //no caching

   if($this->config["type"]=="Registration")
    return false; //no caching
   else if($this->config["type"]=="Password")
    return false; //no caching
   else if($this->config["type"]=="Login") //login/logout
   {
    $cacheTime=0; //user config time
    $cacheKey=$this->plugin->name."_".($_config->userAnonymous()?"loggedout":"loggedin".(strstr($this->config["logoutText"], "%u")?"_".$_config->get("usernr"):"")).".html";
   }

   return true;
  }

  function output()
  {
   global $_config;

   if($this->config["httpsRedirect"]&&!isset($_SERVER["HTTPS"])) //redirect to HTTPS
   {
    //HTTPS requires secure coookie
    $params=session_get_cookie_params();

    if(!$params["secure"])
     session_set_cookie_params($params["lifetime"], $params["path"], $params["domain"], true);

    unset($params);

    $url="https://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
   }
   else
    $url=false;

   $output="";
   if($this->config["type"]=="Registration"&&(request("e")!="login"&&request("e")!="logout"))
   {
    $d=Data::cache($_config->get("usermodule"), "add", "item");

    $d->field["catnr"]["properties"].=";hidden";
    if($this->config["registrationcatnr"])
     $d->setValue("catnr", $this->config["registrationcatnr"]);

    $d->field["usersAdditionalGroups"]["properties"].=";hidden";
    $d->unsetValue("usersAdditionalGroups");

    $d->field["backend"]["properties"].=";hidden";
    $d->unsetValue("backend");

    if($this->config["useCaptcha"])
    {
     $d->addField("captcha", "captcha", "show;form", "", 0, 5, "", "Captcha");
     $d->setRequestValue("captcha");
    }

    $hs=new History();
    $hs->cms();

    $config=Array();
    $config["showSubmitAdditional"]=false;
    $config["reloadPage"]=false;

    $cms=new CMS($config);
    $cms->setData($d);
    $cms->referenceManipulation=false;

    foreach($this->plugin->vars as $k => $v)
     $cms->addVar($k, $v);

    $output.=$cms->form($url);
   }
   else if($this->config["type"]=="Password")
   {
    $d=Data::cache($_config->get("usermodule"), "user", "password");

    $hs=new History();
    $hs->cms();

    $config=Array();
    $config["showSubmitAdditional"]=false;

    $cms=new CMS($config);
    $cms->setData($d);
    $cms->referenceManipulation=false;

    foreach($this->plugin->vars as $k => $v)
     $cms->addVar($k, $v);

    $output.=$cms->form($url);
   }
   else if($this->config["type"]=="Login") //login/logout
   {
    $config=$this->config;
    $config["handleSubmit"]=false;
    $config["reloadPage"]=false;
    $config["anchoring"]=false;

    $config["showTitles"]=false;
    $config["showText"]=false;
    $config["showTips"]=false;

    $config["showFields"]=true;
    $config["showSubmit"]=true;
    $config["showCancel"]=false;

    $cms=new CMS($config);

    if($_config->userAnonymous()) //not logged in
    {
     $output.="<div class=\"logintext\">".$this->config["loginText"]."</div>\n";

     $d=Data::cache($_config->get("usermodule"), "user", "login");
     $d->setDefaultValue("e"); //make sure extra is set to login
     $d->field["nr"]["use"]="sql"; //don't submit nr field

     $cms->setData($d);
     $cms->referenceManipulation=false;

     foreach($this->plugin->vars as $k => $v)
      $cms->addVar($k, $v);

     if($cms->config["showErrors"]&&$this->e->any("fatal"))
      $cms->e->add($this->e);

     $output.=$cms->form($url);

     if($this->config["registrationpage"]&&$this->config["registrationpagenr"])
     {
      //get registration page url name
      $d=Data::cache("pager_categories", "view", "item");
      $d->setValue("nr", $this->config["registrationpagenr"]);
      $d->setShowFields("urlname");

      if($d->get()&&$d->next()&&$d->v["urlname"])
       $page=$d->v["urlname"];
      else
       $page=$this->config["registrationpagenr"];

      $output.="<br/><a href=\"".$this->plugin->baseURL.$page."/\" title=\"".$this->plugin->l->t("Click here to register")."\">".$this->plugin->l->t("Register")."</a>";
     }
    }
    else //logged in
    {
     if(strstr($this->config["logoutText"], "%u")) //username (title) in text
     {
      //get username
      $d=Data::cache($_config->get("usermodule"), "view", "item");
      $d->setValue($d->getID(), $_config->get("usernr"));

      $titleFields=$d->check("properties", "title");
      $d->setShowFields($titleFields);

      if(!$d->get()||!$d->next())
      {
       $this->e->add($d->e);
       return false;
      }
      else //username found
      {
       $tmp="";
       foreach($titleFields as $field)
        $tmp.=$d->v[$field]." ";

       $output.="<div class=\"logouttext\">".str_replace("%u", $tmp, $this->config["logoutText"])."</div>\n";
      }
     }
     else //no username (title) in text
      $output.="<div class=\"logouttext\">".$this->config["logoutText"]."</div>\n";

     if($this->config["showLogout"]) //show logout
     {
      $d=Data::cache($_config->get("usermodule"), "user", "logout");
      $d->setDefaultValue("e"); //make sure extra is set to login
      $d->field["nr"]["use"]="sql"; //don't submit nr field

      $cms->setData($d);
      $cms->referenceManipulation=false;

      foreach($this->plugin->vars as $k => $v)
       $cms->addVar($k, $v);

      $output.=$cms->form($url);
     }

     if($this->config["passwordpage"]&&$this->config["passwordpagenr"])
     {
      //get password page url name
      $d=Data::cache("pager_categories", "view", "item");
      $d->setValue("nr", $this->config["passwordpagenr"]);
      $d->setShowFields("urlname");

      if($d->get()&&$d->next()&&$d->v["urlname"])
       $page=$d->v["urlname"];
      else
       $page=$this->config["passwordpagenr"];

      $output.="<br/><a href=\"".$this->plugin->baseURL.$page."/\" title=\"".$this->plugin->l->t("Click here to change your password")."\">".$this->plugin->l->t("Change password")."</a>";
     }
    }
   }

   return $output;
  }

 }
?>
